package com.sun.beans.finder;

import sun.reflect.misc.ReflectUtil;

public final class ClassFinder
{
    public static Class<?> findClass(String className) throws ClassNotFoundException {
        ReflectUtil.checkPackageAccess(className);
        try {
            ClassLoader loader = Thread.currentThread().getContextClassLoader();
            if (loader == null) {
                loader = ClassLoader.getSystemClassLoader();
            }
            if (loader != null) {
                return Class.forName(className, false, loader);
            }
        }
        catch (ClassNotFoundException ex) {}
        catch (SecurityException ex2) {}
        return Class.forName(className);
    }
    
    public static Class<?> findClass(String s, ClassLoader loader) throws ClassNotFoundException {
        ReflectUtil.checkPackageAccess(s);
        if (loader != null) {
            try {
                return Class.forName(s, false, loader);
            }
            catch (ClassNotFoundException ex) {}
            catch (SecurityException ex2) {}
        }
        return findClass(s);
    }
    
    public static Class<?> resolveClass(String s) throws ClassNotFoundException {
        return resolveClass(s, null);
    }
    
    public static Class<?> resolveClass(String s, ClassLoader classLoader) throws ClassNotFoundException {
        Class<Object> type = PrimitiveTypeMap.getType(s);
        return (type == null) ? findClass(s, classLoader) : type;
    }
    
    private ClassFinder() {
    }
}
